-- ------------------------------------------------------------------------------------- --
-- 					TradeSkillMaster_Crafting - AddOn by Sapu94							 	  	  --
--   http://wow.curse.com/downloads/wow-addons/details/tradeskillmaster_crafting.aspx    --
--																													  --
--		This addon is licensed under the CC BY-NC-ND 3.0 license as described at the		  --
--				following url: http://creativecommons.org/licenses/by-nc-nd/3.0/			 	  --
-- 	Please contact the author via email at sapu94@gmail.com with any questions or		  --
--		concerns regarding this license.																	  --
-- ------------------------------------------------------------------------------------- --

-- The following functions are contained attached to this file:
-- Jewelcrafting:HasProfession() - determines if the player is a jewelcrafter

-- The following "global" (within the addon) variables are initialized in this file:
-- Jewelcrafting.slot - hardcoded list of the slot of every craft

-- ===================================================================================== --


-- load the parent file (TSM) into a local variable and register this file as a module
local TSM = select(2, ...)
local L = LibStub("AceLocale-3.0"):GetLocale("TradeSkillMaster_Crafting") -- loads the localization table
local Jewelcrafting = TSM:NewModule("Jewelcrafting", "AceEvent-3.0")

local debug = function(...) TSM:Debug(...) end -- for debugging

-- determines if the player is a jewelcrafter
function Jewelcrafting:HasProfession()
	local professionIDs = {25229, 25230, 28894, 28895, 28897, 51311, 73318}
	for _, id in pairs(professionIDs) do
		if IsSpellKnown(id) then return true end
	end
end

function Jewelcrafting:GetSlot(itemID)
	if not itemID then return end
	return Jewelcrafting.slot[itemID] or #Jewelcrafting.slotList
end

Jewelcrafting.slotList = {L["Red Gems"], L["Blue Gems"], L["Yellow Gems"], L["Purple Gems"], L["Green Gems"],
	L["Orange Gems"], L["Meta Gems"], L["Prismatic Gems"], L["Misc Items"], L["Other"]}

Jewelcrafting.slot = {
	[40111]=1, -- Red Gems
	[40112]=1, -- Red Gems
	[40113]=1, -- Red Gems
	[40116]=1, -- Red Gems
	[40118]=1, -- Red Gems
	[32193]=1, -- Red Gems
	[32194]=1, -- Red Gems
	[32196]=1, -- Red Gems
	[32199]=1, -- Red Gems
	[52206]=1, -- Red Gems
	[52207]=1, -- Red Gems
	[52212]=1, -- Red Gems
	[52216]=1, -- Red Gems
	[52230]=1, -- Red Gems
	[39996]=1, -- Red Gems
	[39997]=1, -- Red Gems
	[39998]=1, -- Red Gems
	[40001]=1, -- Red Gems
	[40003]=1, -- Red Gems
	[24027]=1, -- Red Gems
	[24028]=1, -- Red Gems
	[24030]=1, -- Red Gems
	[24036]=1, -- Red Gems
	[52081]=1, -- Red Gems
	[52082]=1, -- Red Gems
	[52083]=1, -- Red Gems
	[52084]=1, -- Red Gems
	[52085]=1, -- Red Gems
	[39900]=1, -- Red Gems
	[39905]=1, -- Red Gems
	[39908]=1, -- Red Gems
	[39910]=1, -- Red Gems
	[39912]=1, -- Red Gems
	[23094]=1, -- Red Gems
	[23095]=1, -- Red Gems
	[28595]=1, -- Red Gems
	[40119]=2, -- Blue Gems
	[40120]=2, -- Blue Gems
	[40122]=2, -- Blue Gems
	[40125]=2, -- Blue Gems
	[32200]=2, -- Blue Gems
	[32201]=2, -- Blue Gems
	[32203]=2, -- Blue Gems
	[32206]=2, -- Blue Gems
	[52235]=2, -- Blue Gems
	[52242]=2, -- Blue Gems
	[52244]=2, -- Blue Gems
	[52246]=2, -- Blue Gems
	[40008]=2, -- Blue Gems
	[40010]=2, -- Blue Gems
	[40011]=2, -- Blue Gems
	[40014]=2, -- Blue Gems
	[24033]=2, -- Blue Gems
	[24035]=2, -- Blue Gems
	[24039]=2, -- Blue Gems
	[24051]=2, -- Blue Gems
	[52086]=2, -- Blue Gems
	[52087]=2, -- Blue Gems
	[52088]=2, -- Blue Gems
	[52089]=2, -- Blue Gems
	[39915]=2, -- Blue Gems
	[39919]=2, -- Blue Gems
	[39927]=2, -- Blue Gems
	[39932]=2, -- Blue Gems
	[23116]=2, -- Blue Gems
	[23118]=2, -- Blue Gems
	[23119]=2, -- Blue Gems
	[23120]=2, -- Blue Gems
	[40115]=3, -- Yellow Gems
	[40124]=3, -- Yellow Gems
	[40127]=3, -- Yellow Gems
	[40128]=3, -- Yellow Gems
	[32198]=3, -- Yellow Gems
	[32205]=3, -- Yellow Gems
	[32209]=3, -- Yellow Gems
	[35761]=3, -- Yellow Gems
	[52219]=3, -- Yellow Gems
	[52226]=3, -- Yellow Gems
	[52232]=3, -- Yellow Gems
	[52241]=3, -- Yellow Gems
	[52247]=3, -- Yellow Gems
	[40000]=3, -- Yellow Gems
	[40013]=3, -- Yellow Gems
	[40016]=3, -- Yellow Gems
	[40017]=3, -- Yellow Gems
	[24032]=3, -- Yellow Gems
	[24048]=3, -- Yellow Gems
	[24053]=3, -- Yellow Gems
	[35315]=3, -- Yellow Gems
	[52090]=3, -- Yellow Gems
	[52091]=3, -- Yellow Gems
	[52092]=3, -- Yellow Gems
	[52093]=3, -- Yellow Gems
	[52094]=3, -- Yellow Gems
	[39907]=3, -- Yellow Gems
	[39909]=3, -- Yellow Gems
	[39917]=3, -- Yellow Gems
	[39918]=3, -- Yellow Gems
	[23114]=3, -- Yellow Gems
	[23115]=3, -- Yellow Gems
	[40129]=4, -- Purple Gems
	[40130]=4, -- Purple Gems
	[40133]=4, -- Purple Gems
	[40135]=4, -- Purple Gems
	[40139]=4, -- Purple Gems
	[40141]=4, -- Purple Gems
	[40143]=4, -- Purple Gems
	[40153]=4, -- Purple Gems
	[40157]=4, -- Purple Gems
	[40162]=4, -- Purple Gems
	[40164]=4, -- Purple Gems
	[32211]=4, -- Purple Gems
	[32212]=4, -- Purple Gems
	[32215]=4, -- Purple Gems
	[32220]=4, -- Purple Gems
	[32221]=4, -- Purple Gems
	[32225]=4, -- Purple Gems
	[52203]=4, -- Purple Gems
	[52210]=4, -- Purple Gems
	[52213]=4, -- Purple Gems
	[52217]=4, -- Purple Gems
	[52220]=4, -- Purple Gems
	[52221]=4, -- Purple Gems
	[52234]=4, -- Purple Gems
	[52236]=4, -- Purple Gems
	[52238]=4, -- Purple Gems
	[52243]=4, -- Purple Gems
	[52248]=4, -- Purple Gems
	[40022]=4, -- Purple Gems
	[40023]=4, -- Purple Gems
	[40025]=4, -- Purple Gems
	[40026]=4, -- Purple Gems
	[40028]=4, -- Purple Gems
	[40032]=4, -- Purple Gems
	[40034]=4, -- Purple Gems
	[40038]=4, -- Purple Gems
	[40044]=4, -- Purple Gems
	[40049]=4, -- Purple Gems
	[40058]=4, -- Purple Gems
	[24054]=4, -- Purple Gems
	[24055]=4, -- Purple Gems
	[24056]=4, -- Purple Gems
	[24061]=4, -- Purple Gems
	[24065]=4, -- Purple Gems
	[31867]=4, -- Purple Gems
	[32836]=4, -- Purple Gems
	[52095]=4, -- Purple Gems
	[52096]=4, -- Purple Gems
	[52097]=4, -- Purple Gems
	[52098]=4, -- Purple Gems
	[52099]=4, -- Purple Gems
	[52100]=4, -- Purple Gems
	[52101]=4, -- Purple Gems
	[52102]=4, -- Purple Gems
	[52103]=4, -- Purple Gems
	[52104]=4, -- Purple Gems
	[52105]=4, -- Purple Gems
	[39934]=4, -- Purple Gems
	[39935]=4, -- Purple Gems
	[39939]=4, -- Purple Gems
	[39940]=4, -- Purple Gems
	[39942]=4, -- Purple Gems
	[39945]=4, -- Purple Gems
	[39948]=4, -- Purple Gems
	[39957]=4, -- Purple Gems
	[39966]=4, -- Purple Gems
	[39968]=4, -- Purple Gems
	[39979]=4, -- Purple Gems
	[23100]=4, -- Purple Gems
	[23108]=4, -- Purple Gems
	[23109]=4, -- Purple Gems
	[23110]=4, -- Purple Gems
	[23111]=4, -- Purple Gems
	[31866]=4, -- Purple Gems
	[32833]=4, -- Purple Gems
	[40165]=5, -- Green Gems
	[40166]=5, -- Green Gems
	[40167]=5, -- Green Gems
	[40168]=5, -- Green Gems
	[40169]=5, -- Green Gems
	[40171]=5, -- Green Gems
	[40173]=5, -- Green Gems
	[40177]=5, -- Green Gems
	[40179]=5, -- Green Gems
	[40180]=5, -- Green Gems
	[40182]=5, -- Green Gems
	[32223]=5, -- Green Gems
	[32224]=5, -- Green Gems
	[32226]=5, -- Green Gems
	[35758]=5, -- Green Gems
	[35759]=5, -- Green Gems
	[52218]=5, -- Green Gems
	[52223]=5, -- Green Gems
	[52225]=5, -- Green Gems
	[52227]=5, -- Green Gems
	[52228]=5, -- Green Gems
	[52231]=5, -- Green Gems
	[52233]=5, -- Green Gems
	[52237]=5, -- Green Gems
	[52245]=5, -- Green Gems
	[52250]=5, -- Green Gems
	[40086]=5, -- Green Gems
	[40088]=5, -- Green Gems
	[40089]=5, -- Green Gems
	[40090]=5, -- Green Gems
	[40091]=5, -- Green Gems
	[40095]=5, -- Green Gems
	[40098]=5, -- Green Gems
	[40100]=5, -- Green Gems
	[40102]=5, -- Green Gems
	[40105]=5, -- Green Gems
	[40106]=5, -- Green Gems
	[24066]=5, -- Green Gems
	[24067]=5, -- Green Gems
	[33782]=5, -- Green Gems
	[35318]=5, -- Green Gems
	[35707]=5, -- Green Gems
	[52119]=5, -- Green Gems
	[52120]=5, -- Green Gems
	[52121]=5, -- Green Gems
	[52122]=5, -- Green Gems
	[52123]=5, -- Green Gems
	[52124]=5, -- Green Gems
	[52125]=5, -- Green Gems
	[52126]=5, -- Green Gems
	[52127]=5, -- Green Gems
	[52128]=5, -- Green Gems
	[39933]=5, -- Green Gems
	[39975]=5, -- Green Gems
	[39976]=5, -- Green Gems
	[39977]=5, -- Green Gems
	[39978]=5, -- Green Gems
	[39980]=5, -- Green Gems
	[39981]=5, -- Green Gems
	[39982]=5, -- Green Gems
	[39983]=5, -- Green Gems
	[39991]=5, -- Green Gems
	[39992]=5, -- Green Gems
	[23103]=5, -- Green Gems
	[23104]=5, -- Green Gems
	[23105]=5, -- Green Gems
	[68741]=5, -- Green Gems
	[40142]=6, -- Orange Gems
	[40144]=6, -- Orange Gems
	[40145]=6, -- Orange Gems
	[40146]=6, -- Orange Gems
	[40147]=6, -- Orange Gems
	[40149]=6, -- Orange Gems
	[40150]=6, -- Orange Gems
	[40152]=6, -- Orange Gems
	[40154]=6, -- Orange Gems
	[40155]=6, -- Orange Gems
	[40159]=6, -- Orange Gems
	[40160]=6, -- Orange Gems
	[40163]=6, -- Orange Gems
	[32217]=6, -- Orange Gems
	[32218]=6, -- Orange Gems
	[32222]=6, -- Orange Gems
	[35760]=6, -- Orange Gems
	[52204]=6, -- Orange Gems
	[52205]=6, -- Orange Gems
	[52208]=6, -- Orange Gems
	[52209]=6, -- Orange Gems
	[52211]=6, -- Orange Gems
	[52214]=6, -- Orange Gems
	[52215]=6, -- Orange Gems
	[52222]=6, -- Orange Gems
	[52224]=6, -- Orange Gems
	[52229]=6, -- Orange Gems
	[52239]=6, -- Orange Gems
	[52240]=6, -- Orange Gems
	[52249]=6, -- Orange Gems
	[68356]=6, -- Orange Gems
	[68357]=6, -- Orange Gems
	[68358]=6, -- Orange Gems
	[40037]=6, -- Orange Gems
	[40039]=6, -- Orange Gems
	[40040]=6, -- Orange Gems
	[40041]=6, -- Orange Gems
	[40045]=6, -- Orange Gems
	[40048]=6, -- Orange Gems
	[40050]=6, -- Orange Gems
	[40051]=6, -- Orange Gems
	[40052]=6, -- Orange Gems
	[40055]=6, -- Orange Gems
	[40057]=6, -- Orange Gems
	[40059]=6, -- Orange Gems
	[24058]=6, -- Orange Gems
	[24059]=6, -- Orange Gems
	[24060]=6, -- Orange Gems
	[31868]=6, -- Orange Gems
	[52106]=6, -- Orange Gems
	[52107]=6, -- Orange Gems
	[52108]=6, -- Orange Gems
	[52109]=6, -- Orange Gems
	[52110]=6, -- Orange Gems
	[52111]=6, -- Orange Gems
	[52112]=6, -- Orange Gems
	[52113]=6, -- Orange Gems
	[52114]=6, -- Orange Gems
	[52115]=6, -- Orange Gems
	[52116]=6, -- Orange Gems
	[52117]=6, -- Orange Gems
	[52118]=6, -- Orange Gems
	[39947]=6, -- Orange Gems
	[39949]=6, -- Orange Gems
	[39950]=6, -- Orange Gems
	[39951]=6, -- Orange Gems
	[39952]=6, -- Orange Gems
	[39954]=6, -- Orange Gems
	[39955]=6, -- Orange Gems
	[39956]=6, -- Orange Gems
	[39958]=6, -- Orange Gems
	[39959]=6, -- Orange Gems
	[39965]=6, -- Orange Gems
	[39967]=6, -- Orange Gems
	[23098]=6, -- Orange Gems
	[23099]=6, -- Orange Gems
	[23101]=6, -- Orange Gems
	[31869]=6, -- Orange Gems
	[52289]=7, -- Meta Gems
	[52291]=7, -- Meta Gems
	[52292]=7, -- Meta Gems
	[52293]=7, -- Meta Gems
	[52294]=7, -- Meta Gems
	[52295]=7, -- Meta Gems
	[52296]=7, -- Meta Gems
	[52297]=7, -- Meta Gems
	[52298]=7, -- Meta Gems
	[52299]=7, -- Meta Gems
	[52300]=7, -- Meta Gems
	[52301]=7, -- Meta Gems
	[52302]=7, -- Meta Gems
	[41285]=7, -- Meta Gems
	[41307]=7, -- Meta Gems
	[41333]=7, -- Meta Gems
	[41335]=7, -- Meta Gems
	[41339]=7, -- Meta Gems
	[41375]=7, -- Meta Gems
	[41376]=7, -- Meta Gems
	[41377]=7, -- Meta Gems
	[41378]=7, -- Meta Gems
	[41379]=7, -- Meta Gems
	[41380]=7, -- Meta Gems
	[41381]=7, -- Meta Gems
	[41382]=7, -- Meta Gems
	[41385]=7, -- Meta Gems
	[41389]=7, -- Meta Gems
	[41395]=7, -- Meta Gems
	[41396]=7, -- Meta Gems
	[41397]=7, -- Meta Gems
	[41398]=7, -- Meta Gems
	[41400]=7, -- Meta Gems
	[41401]=7, -- Meta Gems
	[25890]=7, -- Meta Gems
	[25893]=7, -- Meta Gems
	[25894]=7, -- Meta Gems
	[25895]=7, -- Meta Gems
	[25896]=7, -- Meta Gems
	[25897]=7, -- Meta Gems
	[25898]=7, -- Meta Gems
	[25899]=7, -- Meta Gems
	[25901]=7, -- Meta Gems
	[32409]=7, -- Meta Gems
	[32410]=7, -- Meta Gems
	[34220]=7, -- Meta Gems
	[35501]=7, -- Meta Gems
	[35503]=7, -- Meta Gems
	[68778]=7, -- Meta Gems
	[68779]=7, -- Meta Gems
	[68780]=7, -- Meta Gems
	[49110]=8, -- Prismatic Gems
	[42702]=8, -- Prismatic Gems
	[42701]=8, -- Prismatic Gems
	[45054]=8, -- Prismatic Gems
	[31398]=9, -- Misc Items
	[24123]=9, -- Misc Items
	[24122]=9, -- Misc Items
	[31399]=9, -- Misc Items
	[34363]=9, -- Misc Items
	[34362]=9, -- Misc Items
	[34361]=9, -- Misc Items
	[42647]=9, -- Misc Items
	[42646]=9, -- Misc Items
	[42645]=9, -- Misc Items
	[42644]=9, -- Misc Items
	[42643]=9, -- Misc Items
	[42642]=9, -- Misc Items
	[43582]=9, -- Misc Items
	[52487]=9, -- Misc Items
	[52486]=9, -- Misc Items
	[52485]=9, -- Misc Items
	[30804]=9, -- Misc Items
	[20826]=9, -- Misc Items
	[20832]=9, -- Misc Items
	[45627]=9, -- Misc Items
	[29157]=9, -- Misc Items
	[29158]=9, -- Misc Items
	[20964]=9, -- Misc Items
	[20969]=9, -- Misc Items
	[21766]=9, -- Misc Items
	[21753]=9, -- Misc Items
	[21774]=9, -- Misc Items
	[21768]=9, -- Misc Items
	[21792]=9, -- Misc Items
	[21779]=9, -- Misc Items
	[21793]=9, -- Misc Items
	[21780]=9, -- Misc Items
	[32772]=9, -- Misc Items
	[32774]=9, -- Misc Items
	[32508]=9, -- Misc Items
	[24088]=9, -- Misc Items
	[24114]=9, -- Misc Items
	[24087]=9, -- Misc Items
	[24079]=9, -- Misc Items
	[24110]=9, -- Misc Items
	[24106]=9, -- Misc Items
	[24082]=9, -- Misc Items
	[24080]=9, -- Misc Items
	[30825]=9, -- Misc Items
	[24116]=9, -- Misc Items
	[24098]=9, -- Misc Items
	[24097]=9, -- Misc Items
	[24095]=9, -- Misc Items
	[24093]=9, -- Misc Items
	[24092]=9, -- Misc Items
	[24085]=9, -- Misc Items
	[32776]=9, -- Misc Items
	[24121]=9, -- Misc Items
	[24117]=9, -- Misc Items
	[24089]=9, -- Misc Items
	[24086]=9, -- Misc Items
	[42338]=9, -- Misc Items
	[42340]=9, -- Misc Items
	[42339]=9, -- Misc Items
	[43498]=9, -- Misc Items
	[43482]=9, -- Misc Items
	[43253]=9, -- Misc Items
	[43252]=9, -- Misc Items
	[43251]=9, -- Misc Items
	[43250]=9, -- Misc Items
	[45813]=9, -- Misc Items
	[45812]=9, -- Misc Items
	[45809]=9, -- Misc Items
	[45808]=9, -- Misc Items
	[52493]=9, -- Misc Items
	[52350]=9, -- Misc Items
	[52348]=9, -- Misc Items
	[52323]=9, -- Misc Items
	[52322]=9, -- Misc Items
	[52321]=9, -- Misc Items
	[52320]=9, -- Misc Items
	[52319]=9, -- Misc Items
	[52318]=9, -- Misc Items
	[21931]=9, -- Misc Items
	[20906]=9, -- Misc Items
	[21932]=9, -- Misc Items
	[25439]=9, -- Misc Items
	[25438]=9, -- Misc Items
	[21934]=9, -- Misc Items
	[20821]=9, -- Misc Items
	[21933]=9, -- Misc Items
	[20907]=9, -- Misc Items
	[20820]=9, -- Misc Items
	[20818]=9, -- Misc Items
	[20823]=9, -- Misc Items
	[30419]=9, -- Misc Items
	[31154]=9, -- Misc Items
	[20827]=9, -- Misc Items
	[20828]=9, -- Misc Items
	[30420]=9, -- Misc Items
	[20909]=9, -- Misc Items
	[20830]=9, -- Misc Items
	[20950]=9, -- Misc Items
	[20954]=9, -- Misc Items
	[20833]=9, -- Misc Items
	[20955]=9, -- Misc Items
	[20958]=9, -- Misc Items
	[20831]=9, -- Misc Items
	[20966]=9, -- Misc Items
	[20960]=9, -- Misc Items
	[20959]=9, -- Misc Items
	[20961]=9, -- Misc Items
	[20967]=9, -- Misc Items
	[21755]=9, -- Misc Items
	[30421]=9, -- Misc Items
	[21764]=9, -- Misc Items
	[21765]=9, -- Misc Items
	[21754]=9, -- Misc Items
	[21767]=9, -- Misc Items
	[30422]=9, -- Misc Items
	[29159]=9, -- Misc Items
	[21790]=9, -- Misc Items
	[21775]=9, -- Misc Items
	[21778]=9, -- Misc Items
	[29160]=9, -- Misc Items
	[24078]=9, -- Misc Items
	[24077]=9, -- Misc Items
	[24075]=9, -- Misc Items
	[24074]=9, -- Misc Items
	[24076]=9, -- Misc Items
	[43245]=9, -- Misc Items
	[43244]=9, -- Misc Items
	[42337]=9, -- Misc Items
	[42336]=9, -- Misc Items
	[43249]=9, -- Misc Items
	[43248]=9, -- Misc Items
	[52306]=9, -- Misc Items
	[52307]=9, -- Misc Items
	[52309]=9, -- Misc Items
	[52308]=9, -- Misc Items
	[52492]=9, -- Misc Items
	[52489]=9, -- Misc Items
}