-- ------------------------------------------------------------------------------------- --
-- 					TradeSkillMaster_Crafting - AddOn by Sapu94							 	  	  --
--   http://wow.curse.com/downloads/wow-addons/details/tradeskillmaster_crafting.aspx    --
--																													  --
--		This addon is licensed under the CC BY-NC-ND 3.0 license as described at the		  --
--				following url: http://creativecommons.org/licenses/by-nc-nd/3.0/			 	  --
-- 	Please contact the author via email at sapu94@gmail.com with any questions or		  --
--		concerns regarding this license.																	  --
-- ------------------------------------------------------------------------------------- --

-- The following functions are contained attached to this file:
-- Leatherworking:HasProfession() - determines if the player is an leatherworker

-- The following "global" (within the addon) variables are initialized in this file:
-- Leatherworking.slot - hardcoded list of the slot of every craft

-- ===================================================================================== --


-- load the parent file (TSM) into a local variable and register this file as a module
local TSM = select(2, ...)
local L = LibStub("AceLocale-3.0"):GetLocale("TradeSkillMaster_Crafting") -- loads the localization table
local Leatherworking = TSM:NewModule("Leatherworking", "AceEvent-3.0")

local debug = function(...) TSM:Debug(...) end -- for debugging

-- determines if the player is an leatherworkers
function Leatherworking:HasProfession()
	local professionIDs = {2108, 3104, 3811, 10662, 32549, 51302, 81199}
	for _, id in pairs(professionIDs) do
		if IsSpellKnown(id) then return true end
	end
end

function Leatherworking:GetSlot(itemID)
	if not itemID then return end
	return Leatherworking.slot[itemID] or #Leatherworking.slotList
end

Leatherworking.slotList = {L["Armor - Back"], L["Armor - Chest"], L["Armor - Feet"], L["Armor - Hands"],
	L["Armor - Head"], L["Armor - Legs"], L["Armor - Shoulders"], L["Armor - Waist"], L["Armor - Wrists"],
	L["Bags"], L["Consumables"], L["Leather"], L["Other"]}

Leatherworking.slot = {
	[43565]=1, -- Armor - Back
	[43566]=1, -- Armor - Back
	[33122]=1, -- Armor - Back
	[18509]=1, -- Armor - Back
	[18510]=1, -- Armor - Back
	[18511]=1, -- Armor - Back
	[56548]=1, -- Armor - Back
	[56549]=1, -- Armor - Back
	[56518]=1, -- Armor - Back
	[56519]=1, -- Armor - Back
	[41238]=1, -- Armor - Back
	[38441]=1, -- Armor - Back
	[15138]=1, -- Armor - Back
	[56489]=1, -- Armor - Back
	[56480]=1, -- Armor - Back
	[8215]=1, -- Armor - Back
	[8216]=1, -- Armor - Back
	[5965]=1, -- Armor - Back
	[7377]=1, -- Armor - Back
	[3719]=1, -- Armor - Back
	[2316]=1, -- Armor - Back
	[7283]=1, -- Armor - Back
	[6466]=1, -- Armor - Back
	[2308]=1, -- Armor - Back
	[2310]=1, -- Armor - Back
	[7276]=1, -- Armor - Back
	[56561]=2, -- Armor - Chest
	[56562]=2, -- Armor - Chest
	[56563]=2, -- Armor - Chest
	[56564]=2, -- Armor - Chest
	[47595]=2, -- Armor - Chest
	[47596]=2, -- Armor - Chest
	[47597]=2, -- Armor - Chest
	[47598]=2, -- Armor - Chest
	[47599]=2, -- Armor - Chest
	[47600]=2, -- Armor - Chest
	[47601]=2, -- Armor - Chest
	[47602]=2, -- Armor - Chest
	[43590]=2, -- Armor - Chest
	[43593]=2, -- Armor - Chest
	[43461]=2, -- Armor - Chest
	[29514]=2, -- Armor - Chest
	[33204]=2, -- Armor - Chest
	[22661]=2, -- Armor - Chest
	[22664]=2, -- Armor - Chest
	[20380]=2, -- Armor - Chest
	[56541]=2, -- Armor - Chest
	[56554]=2, -- Armor - Chest
	[56556]=2, -- Armor - Chest
	[56559]=2, -- Armor - Chest
	[56504]=2, -- Armor - Chest
	[43129]=2, -- Armor - Chest
	[43257]=2, -- Armor - Chest
	[43263]=2, -- Armor - Chest
	[43434]=2, -- Armor - Chest
	[43445]=2, -- Armor - Chest
	[43453]=2, -- Armor - Chest
	[38592]=2, -- Armor - Chest
	[44437]=2, -- Armor - Chest
	[44441]=2, -- Armor - Chest
	[44444]=2, -- Armor - Chest
	[25689]=2, -- Armor - Chest
	[25696]=2, -- Armor - Chest
	[19685]=2, -- Armor - Chest
	[19688]=2, -- Armor - Chest
	[20478]=2, -- Armor - Chest
	[20479]=2, -- Armor - Chest
	[15047]=2, -- Armor - Chest
	[15059]=2, -- Armor - Chest
	[15050]=2, -- Armor - Chest
	[15066]=2, -- Armor - Chest
	[15048]=2, -- Armor - Chest
	[15056]=2, -- Armor - Chest
	[15064]=2, -- Armor - Chest
	[15045]=2, -- Armor - Chest
	[8367]=2, -- Armor - Chest
	[8349]=2, -- Armor - Chest
	[2314]=2, -- Armor - Chest
	[56509]=2, -- Armor - Chest
	[38400]=2, -- Armor - Chest
	[38408]=2, -- Armor - Chest
	[38414]=2, -- Armor - Chest
	[38420]=2, -- Armor - Chest
	[25657]=2, -- Armor - Chest
	[25671]=2, -- Armor - Chest
	[25676]=2, -- Armor - Chest
	[25660]=2, -- Armor - Chest
	[15068]=2, -- Armor - Chest
	[15090]=2, -- Armor - Chest
	[15085]=2, -- Armor - Chest
	[15075]=2, -- Armor - Chest
	[15053]=2, -- Armor - Chest
	[15076]=2, -- Armor - Chest
	[8211]=2, -- Armor - Chest
	[8203]=2, -- Armor - Chest
	[8200]=2, -- Armor - Chest
	[8189]=2, -- Armor - Chest
	[8175]=2, -- Armor - Chest
	[5739]=2, -- Armor - Chest
	[4256]=2, -- Armor - Chest
	[7374]=2, -- Armor - Chest
	[7375]=2, -- Armor - Chest
	[5782]=2, -- Armor - Chest
	[4455]=2, -- Armor - Chest
	[4255]=2, -- Armor - Chest
	[2317]=2, -- Armor - Chest
	[4244]=2, -- Armor - Chest
	[20575]=2, -- Armor - Chest
	[5781]=2, -- Armor - Chest
	[6709]=2, -- Armor - Chest
	[4243]=2, -- Armor - Chest
	[2311]=2, -- Armor - Chest
	[2300]=2, -- Armor - Chest
	[5957]=2, -- Armor - Chest
	[49894]=3, -- Armor - Feet
	[49895]=3, -- Armor - Feet
	[49896]=3, -- Armor - Feet
	[49897]=3, -- Armor - Feet
	[45562]=3, -- Armor - Feet
	[45563]=3, -- Armor - Feet
	[45564]=3, -- Armor - Feet
	[45565]=3, -- Armor - Feet
	[43592]=3, -- Armor - Feet
	[43595]=3, -- Armor - Feet
	[43469]=3, -- Armor - Feet
	[43502]=3, -- Armor - Feet
	[44930]=3, -- Armor - Feet
	[32394]=3, -- Armor - Feet
	[32398]=3, -- Armor - Feet
	[29512]=3, -- Armor - Feet
	[16984]=3, -- Armor - Feet
	[16982]=3, -- Armor - Feet
	[56529]=3, -- Armor - Feet
	[56530]=3, -- Armor - Feet
	[56532]=3, -- Armor - Feet
	[56534]=3, -- Armor - Feet
	[43256]=3, -- Armor - Feet
	[43273]=3, -- Armor - Feet
	[43439]=3, -- Armor - Feet
	[43443]=3, -- Armor - Feet
	[43451]=3, -- Armor - Feet
	[38590]=3, -- Armor - Feet
	[44438]=3, -- Armor - Feet
	[44442]=3, -- Armor - Feet
	[44445]=3, -- Armor - Feet
	[25691]=3, -- Armor - Feet
	[25686]=3, -- Armor - Feet
	[29491]=3, -- Armor - Feet
	[29493]=3, -- Armor - Feet
	[29497]=3, -- Armor - Feet
	[29499]=3, -- Armor - Feet
	[25693]=3, -- Armor - Feet
	[22760]=3, -- Armor - Feet
	[18506]=3, -- Armor - Feet
	[19052]=3, -- Armor - Feet
	[56491]=3, -- Armor - Feet
	[56494]=3, -- Armor - Feet
	[38413]=3, -- Armor - Feet
	[38404]=3, -- Armor - Feet
	[38419]=3, -- Armor - Feet
	[38407]=3, -- Armor - Feet
	[25659]=3, -- Armor - Feet
	[25668]=3, -- Armor - Feet
	[25655]=3, -- Armor - Feet
	[25673]=3, -- Armor - Feet
	[15071]=3, -- Armor - Feet
	[15073]=3, -- Armor - Feet
	[8213]=3, -- Armor - Feet
	[8197]=3, -- Armor - Feet
	[8209]=3, -- Armor - Feet
	[7390]=3, -- Armor - Feet
	[7391]=3, -- Armor - Feet
	[2315]=3, -- Armor - Feet
	[2307]=3, -- Armor - Feet
	[2309]=3, -- Armor - Feet
	[2302]=3, -- Armor - Feet
	[34086]=3, -- Armor - Feet
	[34370]=4, -- Armor - Hands
	[34372]=4, -- Armor - Hands
	[34374]=4, -- Armor - Hands
	[34376]=4, -- Armor - Hands
	[29503]=4, -- Armor - Hands
	[29506]=4, -- Armor - Hands
	[29507]=4, -- Armor - Hands
	[29509]=4, -- Armor - Hands
	[29511]=4, -- Armor - Hands
	[22662]=4, -- Armor - Hands
	[22666]=4, -- Armor - Hands
	[19157]=4, -- Armor - Hands
	[56523]=4, -- Armor - Hands
	[56525]=4, -- Armor - Hands
	[56528]=4, -- Armor - Hands
	[56535]=4, -- Armor - Hands
	[56484]=4, -- Armor - Hands
	[43255]=4, -- Armor - Hands
	[43265]=4, -- Armor - Hands
	[43436]=4, -- Armor - Hands
	[43446]=4, -- Armor - Hands
	[43454]=4, -- Armor - Hands
	[29490]=4, -- Armor - Hands
	[29496]=4, -- Armor - Hands
	[25685]=4, -- Armor - Hands
	[19686]=4, -- Armor - Hands
	[19049]=4, -- Armor - Hands
	[20477]=4, -- Armor - Hands
	[20480]=4, -- Armor - Hands
	[15063]=4, -- Armor - Hands
	[21278]=4, -- Armor - Hands
	[20296]=4, -- Armor - Hands
	[8346]=4, -- Armor - Hands
	[8347]=4, -- Armor - Hands
	[18238]=4, -- Armor - Hands
	[4253]=4, -- Armor - Hands
	[7348]=4, -- Armor - Hands
	[56490]=4, -- Armor - Hands
	[38403]=4, -- Armor - Hands
	[38409]=4, -- Armor - Hands
	[38415]=4, -- Armor - Hands
	[38421]=4, -- Armor - Hands
	[25661]=4, -- Armor - Hands
	[25674]=4, -- Armor - Hands
	[25654]=4, -- Armor - Hands
	[25669]=4, -- Armor - Hands
	[15070]=4, -- Armor - Hands
	[15078]=4, -- Armor - Hands
	[15091]=4, -- Armor - Hands
	[15074]=4, -- Armor - Hands
	[15083]=4, -- Armor - Hands
	[8204]=4, -- Armor - Hands
	[8187]=4, -- Armor - Hands
	[5966]=4, -- Armor - Hands
	[17721]=4, -- Armor - Hands
	[4254]=4, -- Armor - Hands
	[4247]=4, -- Armor - Hands
	[7359]=4, -- Armor - Hands
	[7358]=4, -- Armor - Hands
	[7349]=4, -- Armor - Hands
	[4248]=4, -- Armor - Hands
	[7284]=4, -- Armor - Hands
	[7285]=4, -- Armor - Hands
	[6467]=4, -- Armor - Hands
	[2312]=4, -- Armor - Hands
	[4239]=4, -- Armor - Hands
	[29502]=5, -- Armor - Head
	[29504]=5, -- Armor - Head
	[29505]=5, -- Armor - Head
	[29508]=5, -- Armor - Head
	[29510]=5, -- Armor - Head
	[16983]=5, -- Armor - Head
	[56543]=5, -- Armor - Head
	[56547]=5, -- Armor - Head
	[56553]=5, -- Armor - Head
	[56557]=5, -- Armor - Head
	[43132]=5, -- Armor - Head
	[43260]=5, -- Armor - Head
	[43261]=5, -- Armor - Head
	[43447]=5, -- Armor - Head
	[43455]=5, -- Armor - Head
	[25680]=5, -- Armor - Head
	[25681]=5, -- Armor - Head
	[25682]=5, -- Armor - Head
	[25683]=5, -- Armor - Head
	[22759]=5, -- Armor - Head
	[8348]=5, -- Armor - Head
	[8345]=5, -- Armor - Head
	[8174]=5, -- Armor - Head
	[56505]=5, -- Armor - Head
	[56512]=5, -- Armor - Head
	[38437]=5, -- Armor - Head
	[38438]=5, -- Armor - Head
	[38439]=5, -- Armor - Head
	[38440]=5, -- Armor - Head
	[15080]=5, -- Armor - Head
	[15094]=5, -- Armor - Head
	[15086]=5, -- Armor - Head
	[8208]=5, -- Armor - Head
	[8191]=5, -- Armor - Head
	[8214]=5, -- Armor - Head
	[8201]=5, -- Armor - Head
	[8176]=5, -- Armor - Head
	[49898]=6, -- Armor - Legs
	[49899]=6, -- Armor - Legs
	[49900]=6, -- Armor - Legs
	[49901]=6, -- Armor - Legs
	[43458]=6, -- Armor - Legs
	[43495]=6, -- Armor - Legs
	[44931]=6, -- Armor - Legs
	[32396]=6, -- Armor - Legs
	[32400]=6, -- Armor - Legs
	[56545]=6, -- Armor - Legs
	[56552]=6, -- Armor - Legs
	[56555]=6, -- Armor - Legs
	[56558]=6, -- Armor - Legs
	[56513]=6, -- Armor - Legs
	[42731]=6, -- Armor - Legs
	[43271]=6, -- Armor - Legs
	[43438]=6, -- Armor - Legs
	[43448]=6, -- Armor - Legs
	[43456]=6, -- Armor - Legs
	[38591]=6, -- Armor - Legs
	[44436]=6, -- Armor - Legs
	[44440]=6, -- Armor - Legs
	[44443]=6, -- Armor - Legs
	[25690]=6, -- Armor - Legs
	[25687]=6, -- Armor - Legs
	[29489]=6, -- Armor - Legs
	[29492]=6, -- Armor - Legs
	[29495]=6, -- Armor - Legs
	[29498]=6, -- Armor - Legs
	[25692]=6, -- Armor - Legs
	[15052]=6, -- Armor - Legs
	[15062]=6, -- Armor - Legs
	[20295]=6, -- Armor - Legs
	[15060]=6, -- Armor - Legs
	[15065]=6, -- Armor - Legs
	[15057]=6, -- Armor - Legs
	[15046]=6, -- Armor - Legs
	[56508]=6, -- Armor - Legs
	[38401]=6, -- Armor - Legs
	[38410]=6, -- Armor - Legs
	[38416]=6, -- Armor - Legs
	[38422]=6, -- Armor - Legs
	[25656]=6, -- Armor - Legs
	[25675]=6, -- Armor - Legs
	[25670]=6, -- Armor - Legs
	[25662]=6, -- Armor - Legs
	[15095]=6, -- Armor - Legs
	[15087]=6, -- Armor - Legs
	[15069]=6, -- Armor - Legs
	[15079]=6, -- Armor - Legs
	[15072]=6, -- Armor - Legs
	[15054]=6, -- Armor - Legs
	[8212]=6, -- Armor - Legs
	[8206]=6, -- Armor - Legs
	[8185]=6, -- Armor - Legs
	[8202]=6, -- Armor - Legs
	[8193]=6, -- Armor - Legs
	[5963]=6, -- Armor - Legs
	[7373]=6, -- Armor - Legs
	[5962]=6, -- Armor - Legs
	[5961]=6, -- Armor - Legs
	[5958]=6, -- Armor - Legs
	[7282]=6, -- Armor - Legs
	[4242]=6, -- Armor - Legs
	[7280]=6, -- Armor - Legs
	[2303]=6, -- Armor - Legs
	[43481]=7, -- Armor - Shoulders
	[56527]=7, -- Armor - Shoulders
	[56531]=7, -- Armor - Shoulders
	[56540]=7, -- Armor - Shoulders
	[56544]=7, -- Armor - Shoulders
	[56498]=7, -- Armor - Shoulders
	[43130]=7, -- Armor - Shoulders
	[43258]=7, -- Armor - Shoulders
	[43262]=7, -- Armor - Shoulders
	[43433]=7, -- Armor - Shoulders
	[43449]=7, -- Armor - Shoulders
	[43457]=7, -- Armor - Shoulders
	[19689]=7, -- Armor - Shoulders
	[19058]=7, -- Armor - Shoulders
	[15051]=7, -- Armor - Shoulders
	[15049]=7, -- Armor - Shoulders
	[15058]=7, -- Armor - Shoulders
	[15061]=7, -- Armor - Shoulders
	[15067]=7, -- Armor - Shoulders
	[56495]=7, -- Armor - Shoulders
	[38411]=7, -- Armor - Shoulders
	[38417]=7, -- Armor - Shoulders
	[38402]=7, -- Armor - Shoulders
	[38424]=7, -- Armor - Shoulders
	[15096]=7, -- Armor - Shoulders
	[15055]=7, -- Armor - Shoulders
	[15081]=7, -- Armor - Shoulders
	[8207]=7, -- Armor - Shoulders
	[8210]=7, -- Armor - Shoulders
	[8192]=7, -- Armor - Shoulders
	[5964]=7, -- Armor - Shoulders
	[4252]=7, -- Armor - Shoulders
	[7352]=7, -- Armor - Shoulders
	[4251]=7, -- Armor - Shoulders
	[56536]=8, -- Armor - Waist
	[56537]=8, -- Armor - Waist
	[56538]=8, -- Armor - Waist
	[56539]=8, -- Armor - Waist
	[45553]=8, -- Armor - Waist
	[45554]=8, -- Armor - Waist
	[45555]=8, -- Armor - Waist
	[45556]=8, -- Armor - Waist
	[43591]=8, -- Armor - Waist
	[43594]=8, -- Armor - Waist
	[43484]=8, -- Armor - Waist
	[32393]=8, -- Armor - Waist
	[32397]=8, -- Armor - Waist
	[30040]=8, -- Armor - Waist
	[30042]=8, -- Armor - Waist
	[30044]=8, -- Armor - Waist
	[30046]=8, -- Armor - Waist
	[19162]=8, -- Armor - Waist
	[19163]=8, -- Armor - Waist
	[19149]=8, -- Armor - Waist
	[56521]=8, -- Armor - Waist
	[56533]=8, -- Armor - Waist
	[56542]=8, -- Armor - Waist
	[56546]=8, -- Armor - Waist
	[43133]=8, -- Armor - Waist
	[43266]=8, -- Armor - Waist
	[43437]=8, -- Armor - Waist
	[43442]=8, -- Armor - Waist
	[43450]=8, -- Armor - Waist
	[25695]=8, -- Armor - Waist
	[29494]=8, -- Armor - Waist
	[29500]=8, -- Armor - Waist
	[25694]=8, -- Armor - Waist
	[22761]=8, -- Armor - Waist
	[18504]=8, -- Armor - Waist
	[19044]=8, -- Armor - Waist
	[4262]=8, -- Armor - Waist
	[6468]=8, -- Armor - Waist
	[56482]=8, -- Armor - Waist
	[56499]=8, -- Armor - Waist
	[38405]=8, -- Armor - Waist
	[38406]=8, -- Armor - Waist
	[38412]=8, -- Armor - Waist
	[38418]=8, -- Armor - Waist
	[15088]=8, -- Armor - Waist
	[15082]=8, -- Armor - Waist
	[15093]=8, -- Armor - Waist
	[4264]=8, -- Armor - Waist
	[7387]=8, -- Armor - Waist
	[4258]=8, -- Armor - Waist
	[4456]=8, -- Armor - Waist
	[4257]=8, -- Armor - Waist
	[4249]=8, -- Armor - Waist
	[4250]=8, -- Armor - Waist
	[5780]=8, -- Armor - Waist
	[4246]=8, -- Armor - Waist
	[4237]=8, -- Armor - Waist
	[47576]=9, -- Armor - Wrists
	[47577]=9, -- Armor - Wrists
	[47579]=9, -- Armor - Wrists
	[47580]=9, -- Armor - Wrists
	[47581]=9, -- Armor - Wrists
	[47582]=9, -- Armor - Wrists
	[47583]=9, -- Armor - Wrists
	[47584]=9, -- Armor - Wrists
	[43459]=9, -- Armor - Wrists
	[32574]=9, -- Armor - Wrists
	[32577]=9, -- Armor - Wrists
	[32580]=9, -- Armor - Wrists
	[32582]=9, -- Armor - Wrists
	[32395]=9, -- Armor - Wrists
	[32399]=9, -- Armor - Wrists
	[22663]=9, -- Armor - Wrists
	[22665]=9, -- Armor - Wrists
	[56520]=9, -- Armor - Wrists
	[56522]=9, -- Armor - Wrists
	[56524]=9, -- Armor - Wrists
	[56526]=9, -- Armor - Wrists
	[43131]=9, -- Armor - Wrists
	[43264]=9, -- Armor - Wrists
	[43435]=9, -- Armor - Wrists
	[43444]=9, -- Armor - Wrists
	[43452]=9, -- Armor - Wrists
	[25697]=9, -- Armor - Wrists
	[19687]=9, -- Armor - Wrists
	[18508]=9, -- Armor - Wrists
	[20476]=9, -- Armor - Wrists
	[20481]=9, -- Armor - Wrists
	[18948]=9, -- Armor - Wrists
	[56481]=9, -- Armor - Wrists
	[56483]=9, -- Armor - Wrists
	[38433]=9, -- Armor - Wrists
	[38434]=9, -- Armor - Wrists
	[38435]=9, -- Armor - Wrists
	[38436]=9, -- Armor - Wrists
	[15092]=9, -- Armor - Wrists
	[15084]=9, -- Armor - Wrists
	[15077]=9, -- Armor - Wrists
	[8205]=9, -- Armor - Wrists
	[8198]=9, -- Armor - Wrists
	[4260]=9, -- Armor - Wrists
	[5783]=9, -- Armor - Wrists
	[7386]=9, -- Armor - Wrists
	[7378]=9, -- Armor - Wrists
	[4259]=9, -- Armor - Wrists
	[7281]=9, -- Armor - Wrists
	[7277]=9, -- Armor - Wrists
	[38399]=10, -- Bags
	[38347]=10, -- Bags
	[44446]=10, -- Bags
	[34105]=10, -- Bags
	[34490]=10, -- Bags
	[29540]=10, -- Bags
	[34482]=10, -- Bags
	[5081]=10, -- Bags
	[56550]=11, -- Consumables
	[56551]=11, -- Consumables
	[38373]=11, -- Consumables
	[38374]=11, -- Consumables
	[44963]=11, -- Consumables
	[29535]=11, -- Consumables
	[29536]=11, -- Consumables
	[56502]=11, -- Consumables
	[56503]=11, -- Consumables
	[38371]=11, -- Consumables
	[38372]=11, -- Consumables
	[29533]=11, -- Consumables
	[29534]=11, -- Consumables
	[18251]=11, -- Consumables
	[56517]=11, -- Consumables
	[38376]=11, -- Consumables
	[29532]=11, -- Consumables
	[29529]=11, -- Consumables
	[29531]=11, -- Consumables
	[34207]=11, -- Consumables
	[29530]=11, -- Consumables
	[29483]=11, -- Consumables
	[29485]=11, -- Consumables
	[29486]=11, -- Consumables
	[29487]=11, -- Consumables
	[29488]=11, -- Consumables
	[29528]=11, -- Consumables
	[56477]=11, -- Consumables
	[38375]=11, -- Consumables
	[49634]=11, -- Consumables
	[49633]=11, -- Consumables
	[34330]=11, -- Consumables
	[25651]=11, -- Consumables
	[25652]=11, -- Consumables
	[25650]=11, -- Consumables
	[25679]=11, -- Consumables
	[15564]=11, -- Consumables
	[8173]=11, -- Consumables
	[4265]=11, -- Consumables
	[2313]=11, -- Consumables
	[2304]=11, -- Consumables
	[18662]=11, -- Consumables
	[33568]=12, -- Leather
	[4236]=12, -- Leather
	[4231]=12, -- Leather
	[4233]=12, -- Leather
	[15407]=12, -- Leather
	[8172]=12, -- Leather
	[38425]=12, -- Leather
	[23793]=12, -- Leather
	[4234]=12, -- Leather
	[56516]=12, -- Leather
	[21887]=12, -- Leather
	[2318]=12, -- Leather
	[2319]=12, -- Leather
	[8170]=12, -- Leather
	[52976]=12, -- Leather
	[4304]=12, -- Leather
}