-- ------------------------------------------------------------------------------------- --
-- 					TradeSkillMaster_Crafting - AddOn by Sapu94							 	  	  --
--   http://wow.curse.com/downloads/wow-addons/details/tradeskillmaster_crafting.aspx    --
--																													  --
--		This addon is licensed under the CC BY-NC-ND 3.0 license as described at the		  --
--				following url: http://creativecommons.org/licenses/by-nc-nd/3.0/			 	  --
-- 	Please contact the author via email at sapu94@gmail.com with any questions or		  --
--		concerns regarding this license.																	  --
-- ------------------------------------------------------------------------------------- --

-- The following functions are contained attached to this file:
-- Tailoring:HasProfession() - determines if the player is an tailor

-- The following "global" (within the addon) variables are initialized in this file:
-- Tailoring.slot - hardcoded list of the slot of every craft

-- ===================================================================================== --


-- load the parent file (TSM) into a local variable and register this file as a module
local TSM = select(2, ...)
local L = LibStub("AceLocale-3.0"):GetLocale("TradeSkillMaster_Crafting") -- loads the localization table
local Tailoring = TSM:NewModule("Tailoring", "AceEvent-3.0")

local debug = function(...) TSM:Debug(...) end -- for debugging

-- determines if the player is an tailor
function Tailoring:HasProfession()
	local professionIDs = {3908, 3909, 3910, 12180, 26790, 51309, 75156}
	for _, id in pairs(professionIDs) do
		if IsSpellKnown(id) then return true end
	end
end

function Tailoring:GetSlot(itemID)
	if not itemID then return end
	return Tailoring.slot[itemID] or #Tailoring.slotList
end

Tailoring.slotList = {L["Armor - Back"], L["Armor - Chest"], L["Armor - Feet"], L["Armor - Hands"],
	L["Armor - Head"], L["Armor - Legs"], L["Armor - Shoulders"], L["Armor - Waist"],
	L["Armor - Wrists"], L["Bags"], L["Consumables"], L["Cloth"], L["Other"]}

Tailoring.slot = {
	[41609]=1, -- Armor - Back
	[41610]=1, -- Armor - Back
	[32420]=1, -- Armor - Back
	[24258]=1, -- Armor - Back
	[24259]=1, -- Armor - Back
	[24260]=1, -- Armor - Back
	[22658]=1, -- Armor - Back
	[45810]=1, -- Armor - Back
	[45811]=1, -- Armor - Back
	[41608]=1, -- Armor - Back
	[41607]=1, -- Armor - Back
	[24252]=1, -- Armor - Back
	[24253]=1, -- Armor - Back
	[24254]=1, -- Armor - Back
	[30831]=1, -- Armor - Back
	[22660]=1, -- Armor - Back
	[18413]=1, -- Armor - Back
	[14134]=1, -- Armor - Back
	[4327]=1, -- Armor - Back
	[45626]=1, -- Armor - Back
	[14044]=1, -- Armor - Back
	[14103]=1, -- Armor - Back
	[13860]=1, -- Armor - Back
	[4326]=1, -- Armor - Back
	[7056]=1, -- Armor - Back
	[7053]=1, -- Armor - Back
	[4311]=1, -- Armor - Back
	[5542]=1, -- Armor - Back
	[2580]=1, -- Armor - Back
	[2584]=1, -- Armor - Back
	[2570]=1, -- Armor - Back
	[47603]=2, -- Armor - Chest
	[47604]=2, -- Armor - Chest
	[47605]=2, -- Armor - Chest
	[47606]=2, -- Armor - Chest
	[43583]=2, -- Armor - Chest
	[42100]=2, -- Armor - Chest
	[42101]=2, -- Armor - Chest
	[42102]=2, -- Armor - Chest
	[21875]=2, -- Armor - Chest
	[21848]=2, -- Armor - Chest
	[21871]=2, -- Armor - Chest
	[21865]=2, -- Armor - Chest
	[22652]=2, -- Armor - Chest
	[19156]=2, -- Armor - Chest
	[54494]=2, -- Armor - Chest
	[54495]=2, -- Armor - Chest
	[54475]=2, -- Armor - Chest
	[41554]=2, -- Armor - Chest
	[43972]=2, -- Armor - Chest
	[41525]=2, -- Armor - Chest
	[21868]=2, -- Armor - Chest
	[30839]=2, -- Armor - Chest
	[21861]=2, -- Armor - Chest
	[21862]=2, -- Armor - Chest
	[30459]=2, -- Armor - Chest
	[22756]=2, -- Armor - Chest
	[19682]=2, -- Armor - Chest
	[18486]=2, -- Armor - Chest
	[14138]=2, -- Armor - Chest
	[14136]=2, -- Armor - Chest
	[10021]=2, -- Armor - Chest
	[54486]=2, -- Armor - Chest
	[41549]=2, -- Armor - Chest
	[41515]=2, -- Armor - Chest
	[21855]=2, -- Armor - Chest
	[21854]=2, -- Armor - Chest
	[14106]=2, -- Armor - Chest
	[14128]=2, -- Armor - Chest
	[14141]=2, -- Armor - Chest
	[14100]=2, -- Armor - Chest
	[13857]=2, -- Armor - Chest
	[13858]=2, -- Armor - Chest
	[14042]=2, -- Armor - Chest
	[13868]=2, -- Armor - Chest
	[13869]=2, -- Armor - Chest
	[10042]=2, -- Armor - Chest
	[10004]=2, -- Armor - Chest
	[10007]=2, -- Armor - Chest
	[10001]=2, -- Armor - Chest
	[7063]=2, -- Armor - Chest
	[9998]=2, -- Armor - Chest
	[7058]=2, -- Armor - Chest
	[7051]=2, -- Armor - Chest
	[7065]=2, -- Armor - Chest
	[4324]=2, -- Armor - Chest
	[5770]=2, -- Armor - Chest
	[5766]=2, -- Armor - Chest
	[6264]=2, -- Armor - Chest
	[2585]=2, -- Armor - Chest
	[6263]=2, -- Armor - Chest
	[2582]=2, -- Armor - Chest
	[2578]=2, -- Armor - Chest
	[6242]=2, -- Armor - Chest
	[6239]=2, -- Armor - Chest
	[6240]=2, -- Armor - Chest
	[2572]=2, -- Armor - Chest
	[6238]=2, -- Armor - Chest
	[6241]=2, -- Armor - Chest
	[10053]=2, -- Armor - Chest
	[38277]=2, -- Armor - Chest
	[10040]=2, -- Armor - Chest
	[6786]=2, -- Armor - Chest
	[2568]=2, -- Armor - Chest
	[6787]=2, -- Armor - Chest
	[10036]=2, -- Armor - Chest
	[21154]=2, -- Armor - Chest
	[21542]=2, -- Armor - Chest
	[34085]=2, -- Armor - Chest
	[34087]=2, -- Armor - Chest
	[54441]=2, -- Armor - Chest
	[49890]=3, -- Armor - Feet
	[49893]=3, -- Armor - Feet
	[45566]=3, -- Armor - Feet
	[45567]=3, -- Armor - Feet
	[43585]=3, -- Armor - Feet
	[32391]=3, -- Armor - Feet
	[21870]=3, -- Armor - Feet
	[54490]=3, -- Armor - Feet
	[54499]=3, -- Armor - Feet
	[41985]=3, -- Armor - Feet
	[42096]=3, -- Armor - Feet
	[43970]=3, -- Armor - Feet
	[21867]=3, -- Armor - Feet
	[30461]=3, -- Armor - Feet
	[21860]=3, -- Armor - Feet
	[19684]=3, -- Armor - Feet
	[20537]=3, -- Armor - Feet
	[19056]=3, -- Armor - Feet
	[15802]=3, -- Armor - Feet
	[4320]=3, -- Armor - Feet
	[54482]=3, -- Armor - Feet
	[54477]=3, -- Armor - Feet
	[41544]=3, -- Armor - Feet
	[41520]=3, -- Armor - Feet
	[21853]=3, -- Armor - Feet
	[14108]=3, -- Armor - Feet
	[13864]=3, -- Armor - Feet
	[10044]=3, -- Armor - Feet
	[10031]=3, -- Armor - Feet
	[10026]=3, -- Armor - Feet
	[4325]=3, -- Armor - Feet
	[4321]=3, -- Armor - Feet
	[4313]=3, -- Armor - Feet
	[2583]=3, -- Armor - Feet
	[4312]=3, -- Armor - Feet
	[2569]=3, -- Armor - Feet
	[10046]=3, -- Armor - Feet
	[6836]=3, -- Armor - Feet
	[42103]=4, -- Armor - Hands
	[42111]=4, -- Armor - Hands
	[42113]=4, -- Armor - Hands
	[34366]=4, -- Armor - Hands
	[34367]=4, -- Armor - Hands
	[21847]=4, -- Armor - Hands
	[21863]=4, -- Armor - Hands
	[22654]=4, -- Armor - Hands
	[14146]=4, -- Armor - Hands
	[16979]=4, -- Armor - Hands
	[54492]=4, -- Armor - Hands
	[54497]=4, -- Armor - Hands
	[54478]=4, -- Armor - Hands
	[41516]=4, -- Armor - Hands
	[42095]=4, -- Armor - Hands
	[30838]=4, -- Armor - Hands
	[18407]=4, -- Armor - Hands
	[18408]=4, -- Armor - Hands
	[18409]=4, -- Armor - Hands
	[10019]=4, -- Armor - Hands
	[54484]=4, -- Armor - Hands
	[41545]=4, -- Armor - Hands
	[44211]=4, -- Armor - Hands
	[21851]=4, -- Armor - Hands
	[13863]=4, -- Armor - Hands
	[14043]=4, -- Armor - Hands
	[14101]=4, -- Armor - Hands
	[14142]=4, -- Armor - Hands
	[13870]=4, -- Armor - Hands
	[10018]=4, -- Armor - Hands
	[10023]=4, -- Armor - Hands
	[10003]=4, -- Armor - Hands
	[7064]=4, -- Armor - Hands
	[7049]=4, -- Armor - Hands
	[4319]=4, -- Armor - Hands
	[7047]=4, -- Armor - Hands
	[4318]=4, -- Armor - Hands
	[4331]=4, -- Armor - Hands
	[4310]=4, -- Armor - Hands
	[4307]=4, -- Armor - Hands
	[24264]=5, -- Armor - Head
	[24266]=5, -- Armor - Head
	[24267]=5, -- Armor - Head
	[54493]=5, -- Armor - Head
	[54496]=5, -- Armor - Head
	[54485]=5, -- Armor - Head
	[41984]=5, -- Armor - Head
	[43971]=5, -- Armor - Head
	[22757]=5, -- Armor - Head
	[14140]=5, -- Armor - Head
	[10041]=5, -- Armor - Head
	[54476]=5, -- Armor - Head
	[41546]=5, -- Armor - Head
	[41521]=5, -- Armor - Head
	[14130]=5, -- Armor - Head
	[13866]=5, -- Armor - Head
	[14111]=5, -- Armor - Head
	[10025]=5, -- Armor - Head
	[10030]=5, -- Armor - Head
	[10033]=5, -- Armor - Head
	[10024]=5, -- Armor - Head
	[10008]=5, -- Armor - Head
	[4323]=5, -- Armor - Head
	[4322]=5, -- Armor - Head
	[7050]=5, -- Armor - Head
	[7048]=5, -- Armor - Head
	[54451]=5, -- Armor - Head
	[54505]=6, -- Armor - Legs
	[54506]=6, -- Armor - Legs
	[49891]=6, -- Armor - Legs
	[49892]=6, -- Armor - Legs
	[32389]=6, -- Armor - Legs
	[24261]=6, -- Armor - Legs
	[24262]=6, -- Armor - Legs
	[24263]=6, -- Armor - Legs
	[19165]=6, -- Armor - Legs
	[54491]=6, -- Armor - Legs
	[54498]=6, -- Armor - Legs
	[41553]=6, -- Armor - Legs
	[42093]=6, -- Armor - Legs
	[43975]=6, -- Armor - Legs
	[21859]=6, -- Armor - Legs
	[19683]=6, -- Armor - Legs
	[20538]=6, -- Armor - Legs
	[14137]=6, -- Armor - Legs
	[54483]=6, -- Armor - Legs
	[54472]=6, -- Armor - Legs
	[41548]=6, -- Armor - Legs
	[41519]=6, -- Armor - Legs
	[21852]=6, -- Armor - Legs
	[14104]=6, -- Armor - Legs
	[14144]=6, -- Armor - Legs
	[13865]=6, -- Armor - Legs
	[13871]=6, -- Armor - Legs
	[14045]=6, -- Armor - Legs
	[14107]=6, -- Armor - Legs
	[14132]=6, -- Armor - Legs
	[10009]=6, -- Armor - Legs
	[10002]=6, -- Armor - Legs
	[9999]=6, -- Armor - Legs
	[7062]=6, -- Armor - Legs
	[7046]=6, -- Armor - Legs
	[4317]=6, -- Armor - Legs
	[10048]=6, -- Armor - Legs
	[4316]=6, -- Armor - Legs
	[10047]=6, -- Armor - Legs
	[4309]=6, -- Armor - Legs
	[4343]=6, -- Armor - Legs
	[10035]=6, -- Armor - Legs
	[38278]=6, -- Armor - Legs
	[10045]=6, -- Armor - Legs
	[21869]=7, -- Armor - Shoulders
	[21874]=7, -- Armor - Shoulders
	[21864]=7, -- Armor - Shoulders
	[16980]=7, -- Armor - Shoulders
	[54487]=7, -- Armor - Shoulders
	[54502]=7, -- Armor - Shoulders
	[54479]=7, -- Armor - Shoulders
	[43973]=7, -- Armor - Shoulders
	[41523]=7, -- Armor - Shoulders
	[22758]=7, -- Armor - Shoulders
	[19050]=7, -- Armor - Shoulders
	[19059]=7, -- Armor - Shoulders
	[14139]=7, -- Armor - Shoulders
	[54474]=7, -- Armor - Shoulders
	[41550]=7, -- Armor - Shoulders
	[41513]=7, -- Armor - Shoulders
	[14112]=7, -- Armor - Shoulders
	[13867]=7, -- Armor - Shoulders
	[10028]=7, -- Armor - Shoulders
	[10029]=7, -- Armor - Shoulders
	[10027]=7, -- Armor - Shoulders
	[7059]=7, -- Armor - Shoulders
	[7060]=7, -- Armor - Shoulders
	[7057]=7, -- Armor - Shoulders
	[4315]=7, -- Armor - Shoulders
	[4314]=7, -- Armor - Shoulders
	[54503]=8, -- Armor - Waist
	[54504]=8, -- Armor - Waist
	[45557]=8, -- Armor - Waist
	[45558]=8, -- Armor - Waist
	[43584]=8, -- Armor - Waist
	[32390]=8, -- Armor - Waist
	[30036]=8, -- Armor - Waist
	[30038]=8, -- Armor - Waist
	[21873]=8, -- Armor - Waist
	[21846]=8, -- Armor - Waist
	[24255]=8, -- Armor - Waist
	[24256]=8, -- Armor - Waist
	[24257]=8, -- Armor - Waist
	[18405]=8, -- Armor - Waist
	[54489]=8, -- Armor - Waist
	[54500]=8, -- Armor - Waist
	[41986]=8, -- Armor - Waist
	[43969]=8, -- Armor - Waist
	[30460]=8, -- Armor - Waist
	[20539]=8, -- Armor - Waist
	[19047]=8, -- Armor - Waist
	[54481]=8, -- Armor - Waist
	[54471]=8, -- Armor - Waist
	[41543]=8, -- Armor - Waist
	[41522]=8, -- Armor - Waist
	[21850]=8, -- Armor - Waist
	[14143]=8, -- Armor - Waist
	[13856]=8, -- Armor - Waist
	[4329]=8, -- Armor - Waist
	[7061]=8, -- Armor - Waist
	[4328]=8, -- Armor - Waist
	[7052]=8, -- Armor - Waist
	[7055]=8, -- Armor - Waist
	[7026]=8, -- Armor - Waist
	[47585]=9, -- Armor - Wrists
	[47586]=9, -- Armor - Wrists
	[47587]=9, -- Armor - Wrists
	[47588]=9, -- Armor - Wrists
	[32584]=9, -- Armor - Wrists
	[32586]=9, -- Armor - Wrists
	[32392]=9, -- Armor - Wrists
	[22655]=9, -- Armor - Wrists
	[18263]=9, -- Armor - Wrists
	[54488]=9, -- Armor - Wrists
	[54501]=9, -- Armor - Wrists
	[41555]=9, -- Armor - Wrists
	[43974]=9, -- Armor - Wrists
	[41528]=9, -- Armor - Wrists
	[21866]=9, -- Armor - Wrists
	[24249]=9, -- Armor - Wrists
	[24250]=9, -- Armor - Wrists
	[24251]=9, -- Armor - Wrists
	[30837]=9, -- Armor - Wrists
	[54480]=9, -- Armor - Wrists
	[54473]=9, -- Armor - Wrists
	[41551]=9, -- Armor - Wrists
	[41512]=9, -- Armor - Wrists
	[21849]=9, -- Armor - Wrists
	[4308]=9, -- Armor - Wrists
	[21342]=10, -- Bags
	[21858]=10, -- Bags
	[54444]=10, -- Bags
	[54445]=10, -- Bags
	[41597]=10, -- Bags
	[41598]=10, -- Bags
	[41600]=10, -- Bags
	[45773]=10, -- Bags
	[21872]=10, -- Bags
	[38225]=10, -- Bags
	[21876]=10, -- Bags
	[14156]=10, -- Bags
	[21341]=10, -- Bags
	[54443]=10, -- Bags
	[54446]=10, -- Bags
	[41599]=10, -- Bags
	[21843]=10, -- Bags
	[22249]=10, -- Bags
	[22252]=10, -- Bags
	[24270]=10, -- Bags
	[21841]=10, -- Bags
	[14155]=10, -- Bags
	[22248]=10, -- Bags
	[22251]=10, -- Bags
	[21340]=10, -- Bags
	[22246]=10, -- Bags
	[14046]=10, -- Bags
	[10050]=10, -- Bags
	[10051]=10, -- Bags
	[4245]=10, -- Bags
	[5764]=10, -- Bags
	[5765]=10, -- Bags
	[4240]=10, -- Bags
	[4241]=10, -- Bags
	[5763]=10, -- Bags
	[4238]=10, -- Bags
	[5762]=10, -- Bags
	[54448]=11, -- Consumables
	[54450]=11, -- Consumables
	[41602]=11, -- Consumables
	[41604]=11, -- Consumables
	[24274]=11, -- Consumables
	[24276]=11, -- Consumables
	[54447]=11, -- Consumables
	[54449]=11, -- Consumables
	[41601]=11, -- Consumables
	[41603]=11, -- Consumables
	[24273]=11, -- Consumables
	[24275]=11, -- Consumables
	[54442]=11, -- Consumables
	[41509]=11, -- Consumables
	[24268]=11, -- Consumables
	[41593]=12, -- Cloth
	[41594]=12, -- Cloth
	[41595]=12, -- Cloth
	[21845]=12, -- Cloth
	[24271]=12, -- Cloth
	[24272]=12, -- Cloth
	[41511]=12, -- Cloth
	[21842]=12, -- Cloth
	[53643]=12, -- Cloth
	[21844]=12, -- Cloth
	[41510]=12, -- Cloth
	[21840]=12, -- Cloth
	[14048]=12, -- Cloth
	[14342]=12, -- Cloth
	[4339]=12, -- Cloth
	[4305]=12, -- Cloth
	[2997]=12, -- Cloth
	[2996]=12, -- Cloth
}