  local addon, ns = ...
  local cfg = CreateFrame("Frame")

  -----------------------------
  -- MEDIA
  -----------------------------
  local MediaPath = "Interface\\Addons\\m_ActionBars\\media\\"
  cfg.textures_normal = MediaPath.."icon"
  cfg.textures_pushed = MediaPath.."icon"
  cfg.textures_btbg = "Interface\\Buttons\\WHITE8x8"
  cfg.button_font = "Fonts\\FRIZQT__.TTF"
  
  -----------------------------
  -- CONFIG
  -----------------------------
  --ActionBars config
  cfg.enable_action_bars = true		-- enable action bars modifications
  cfg.size = 30						-- setting up default buttons size
  cfg.spacing = 2					-- spacing between buttons

  cfg.config_mainbar = {		
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 12,	
	--[[button size:]] cfg.size,	--[[spacing between buttons:]] cfg.spacing,
	--[[hide bar:]] false,			--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0.5,
	["Position"] = { a= "BOTTOM",		x=	0,		y= 30	}
	}
  cfg.config_bottomleftbar = {	
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 12,					
	--[[button size:]] cfg.size,	--[[spacing between buttons:]] cfg.spacing,
	--[[hide bar:]] false,			--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0.5,
	["Position"] = { a= "BOTTOM",		x=	0,		y= 62	}
  	}
  cfg.config_bottomrightbar = {	
	--[[orientation:]] "V",			--[[rows(H)/columns(V):]] 2,	--[[buttons:]] 12,					
	--[[button size:]] 33,			--[[spacing between buttons:]] cfg.spacing,
	--[[hide bar:]] false,			--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0,
	["Position"] = { a= "BOTTOMRIGHT",	x=	-5,	y= 500	}
  	}
  cfg.config_leftbar = {		
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 2,	--[[buttons:]] 4,
	--[[button size:]] 30, 			--[[spacing between buttons:]] cfg.spacing,
	--[[hide bar:]] false,			--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0,
	["Position"] = { a= "BOTTOM",	x=	-230,	y= 30	}
 	}
  cfg.config_rightbar = {		
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 2,	--[[buttons:]] 4,
	--[[button size:]] 30,			--[[spacing between buttons:]] cfg.spacing,
	--[[hide bar:]] false,			--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0,
	["Position"] = { a= "BOTTOM",	x=	230,	y= 30	}
	}
  cfg.config_extrabar = {		
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 12,
	--[[button size:]] 30,			--[[spacing between buttons:]] cfg.spacing,
	--[[hide bar:]] true,			--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,  			--[[fade out alpha:]] .3,
	["Position"] = { a= "BOTTOMRIGHT",	x=	-26,	y= 260	}
	}
  cfg.config_shapeshiftbar = {	
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 6,	
	--[[button size:]] 25, 			--[[spacing between buttons:]] cfg.spacing,	
	--[[hide bar:]] false,			--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0,
	["Position"] = { a= "BOTTOM",	x=	-180,	y= 101	}
	}
  cfg.config_petbar = {			
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 10,	
	--[[button size:]] cfg.size,	--[[spacing between buttons:]] cfg.spacing,	
	--[[hide bar:]] false,			--[[show on mouseover:]] true,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] .3,
	["Position"] = { a= "BOTTOM",		x=	0,  	y= 242	}
	}
  cfg.config_totembar = {	
	--[[enable timers:]] true,		--[[button size:]] 32,			--[[spacing between buttons:]] 8,	
	--[[hide bar:]] false,	 		--[[bar alpha:]] 1,
	["Position"] = { a= "BOTTOM",		x=	0,  	y= 238	}
	}
  cfg.config_raidiconbar = {	
	--[[orientation:]] "H",			--[[button size:]] 20,  		--[[spacing between buttons:]] 3,	
	--[[hide bar:]] true,			--[[show on mouseover:]] true,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0.2,
	["Position"] = { a= "BOTTOM",		x=	-2,  	y= 0	}
	}
  cfg.config_markerflarebar = {	
	--[[orientation:]] "H",			--[[button size:]] 23,			--[[spacing between buttons:]] cfg.spacing,	
	--[[hide bar:]] false,			--[[show on mouseover:]] true,	--[[show only when in group:]] true,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0.2,
	["Position"] = { a= "BOTTOMRIGHT",	x=	-5,	y= 190	}
	}
  cfg.config_micromenu = {	
	--[[hide bar:]] true,			--[[show on mouseover:]] false,	--[[scale:]] 0.85,
	["Position"] = { a= "BOTTOMRIGHT",	x=	-25,	y= 300	}
	}
  cfg.config_exitvehiclebtn = {	
	--[[disable:]] false,  			--[[user placed:]] false,
	["Position"] = { a= "BOTTOM",		x=	-380,	y= 238	}
	}
  cfg.config_extrabtn = {
	--[[disable:]] false,
	["Position"] = { a= "BOTTOMRIGHT",		x=	-130,	y= 250	}
	}
	
  --ButtonsStyler config
  cfg.hide_hotkey = false		-- remove key binding text from the bars
  cfg.hide_macro_name = false	-- remove macro name text from the bars
  cfg.count_font_size = 12		-- remove count text from the bars
  cfg.hotkey_font_size = 12		-- font size for the key bindings text
  cfg.name_font_size = 12		-- font size for the macro name text
  cfg.colors = {
       normal = {r =  0,	g =  0, 	b =  0	},
       pushed = {r =  1,	g =  1, 	b =  1	},
    highlight = {r =  .9,	g =  .8,	b =  .6	},
      checked = {r =  .9,	g =  .8,	b =  .6	},
   outofrange = {r =  .8,	g =  .3, 	b =  .2	},
    outofmana = {r =  .3,	g = .3, 	b =  .7	},
       usable = {r =  1,	g =  1, 	b =  1	},
     unusable = {r = .4,	g = .4, 	b = .4	},
	 equipped = {r = .3,	g = .6, 	b = .3	}
  }
  
--my personal settings
--[[ if GetUnitName("player") == "Strigoy" or GetUnitName("player") == "Strig" then
	cfg.config_bottomleftbar = {"H", 1, 12, 30, cfg.spacing, true, false, false, 1, .3,		
		["Position"] = { a= "BOTTOMRIGHT",	x=	-26,	y= 260}}
	cfg.config_extrabar = {"H", 1, 8, cfg.size, cfg.spacing, false, false, false, 1, 0.5,
		["Position"] = { a= "BOTTOM",		x=	0,		y= 183}}
end ]]
  
  -- HANDOVER
  ns.cfg = cfg
